// global configuration
var subjects = ['MAT', 'CJ', 'CHE', 'INF', 'DEJ', 'TV']; // empty - pause
var days = ['Po', 'Út', 'St', 'Čt', 'Pá'];
var pocty = {'pr1':[],'pr2':[]};
var vybrano = {'pr1':[],'pr2':[]};
var pocty_predmetu = [];
var navolene_predmety = [0,0,0,0,0,0];
var pole_barvy = ["#ff0000","#008000","#ffa500","#4169e1","#ffff00","#ff00ff"];
var daysOfWeek = 5;
var maxHoursDay = 7;
var radekCheckTable = 15;

function initApplication() {
  clearArrays();
  
  //1. priklad  
  document.getElementById('rozvrh1').innerHTML = initRozvrh('pr2');
  document.getElementById('graf1').innerHTML = initGraf2('pr2');
  
  //2. prikad
  document.getElementById('rozvrh2').innerHTML = initRozvrh('pr1');
  document.getElementById('graf2').innerHTML = initGraf2('pr1');
  
  //3-priklad
  document.getElementById('rozvrh3').innerHTML = initRozvrh('pr3');
  document.getElementById('graf3').innerHTML = initGraf2('pr3');
  initLegend();
  drawCount();
  
}

// nulovani poli pro dalsi inkrementaci
function clearArrays() {
  var i;
  
  for (i = 0; i < subjects.length; i++) {
    pocty['pr1'][i] = 0;
    pocty['pr2'][i] = 0;
    vybrano['pr1'][i] = 0;
    vybrano['pr2'][i] = 0;
  }
}

// tabulka
function initRozvrh(priklad){
  var i, j, rand;
  var output = "";
  if(priklad != "pr3")
    output += '<h4>Rozvrh</h4>';
  else                                         
    output += '<h4>Sestav si rozvrh</h4>';
    
  output += '<table class="cap5">';

  output += '<tr>';
  output += '<th>&nbsp;</th>';
  for (j = 1; j < maxHoursDay; j++) {
    output += '<th>';
    output += j + '.';
    output += '</th>';  
  }
  output += '</tr>';

  for (i = 0; i < daysOfWeek; i++) {
    output += '<tr>';

    output += '<th>';
    output += days[i];
    output += '</th>';

    for (j = 1; j < maxHoursDay; j++) {            
      if(priklad != 'pr3'){
        rand = Math.floor(Math.random() * subjects.length);
        pocty[priklad][rand] += 1;
        output += '<td>'+subjects[rand]+'</td>';
      }else{
        output += '<td class="drop"></td>';
      }         
    }

    output += '</tr>';
  }
  output += '</table>';
  
  return output;
}

//predmety pro pretahovani
function initLegend(){
  var rozvrh = document.getElementById('rozvrh3');
  let obal = document.createElement('div');
  obal.id = "subjects";
  
  for(let i =0;i<subjects.length;i++){
    let predmet = document.createElement('span');
    predmet.innerHTML = subjects[i];
    predmet.classList.add('drag');
    obal.appendChild(predmet);
  }
  rozvrh.appendChild(obal);
  
  let obal_but = document.createElement('div');
  let button = document.createElement('input');
  button.setAttribute("type", "submit");
  button.setAttribute("value", "Zkontroluj");
  button.setAttribute("id", "vyhodnoceni_pr3");    
  button.classList.add("cap5","print-hide");
  obal_but.appendChild(button); 
  
  button = document.createElement('input');
  button.setAttribute("type", "submit");
  button.setAttribute("value", "Vymazat");
  button.setAttribute("id", "vyhodnoceni_reset"); 
  button.classList.add("cap5","print-hide");
  obal_but.appendChild(button); 
  
  rozvrh.appendChild(obal_but);
  
}

//kresleni poctu hodiny do grafu 3
function drawCount(){
  //vegeneruji si pocty
  for(let i = 0;i<6;i++){
    pocty_predmetu.push(random_int(1,5));
  } 
  //console.log(pocty_predmetu);    
  //vykreslim pocty
  for(let radek=0;radek<6;radek++){
  let posun = 0;
  for(let sloupec=0;sloupec<pocty_predmetu[radek];sloupec++){
      document.getElementById('pr3bunka_'+(radek+posun)).style.backgroundColor = pole_barvy[radek]; 
      //console.log(radek+posun);
      posun += 6;
    } 
  }
      
  
}

// pomocna tabulka
/*
output = '';
for (i = 0; i < subjects.length; i++) {
  output += subjects[i] + ':' + pocty[i] + ' <br />';
}
document.getElementById('neviditelny').innerHTML = output;
*/

// graf

function initGraf2(class_td) {
  var i, j, h;
  var output = "";
  var output_fnc = "";
  if(class_td != "pr3"){
    output += '<h4>Vyklikejte počty hodin</h4>';
    output_fnc = ' onclick="vybarvi(this,\''+class_td+'\');"';
    h = 83;
  }else{
    radekCheckTable = 10;
    output += '<h4>Počty hodin</h4>'; 
    h = 53;
  }                       
    
  output += '<table class="heske">';

  // ostatni radky
  
  for (j = (radekCheckTable-1); j >= 1 ; j-- ) {
     output += '<tr>';
     output += '<th class="osa">' + j + '</th>';
     for (i = 0; i < subjects.length; i++) {  
       output += '<td class="bunka" id="'+class_td+'bunka_' + h +'"'+output_fnc+'></td>';
       h -= 1;
     }
     output += '</tr>';
  }
  
  // prvni radek
  output += '<tr><th>&nbsp;</th>';
  for (i = subjects.length-1; i >= 0; i--) {  
    output += '<th class="subjects">' + subjects[i] + '</th>'; 
  }
  output += '</tr>';
  
  if(class_td != "pr3")
    output +='<tr><td colspan="7"><input type="submit" class="cap5 print-hide" id="vyhodnoceni_'+class_td+'" value="Zkontrolovat" /></td></tr>';
  
  output +='</table>';
  
  return output;
}


function vybarvi(_this,td) {
  var id = _this.id;
  var elm = document.getElementById(id);
  var cislo = id.split('_')[1];
  var prvek = cislo % subjects.length;
  
  if(td == 'pr2'){
    if (!(cislo >= 0 && cislo <= subjects.length - 1)) {       //   && td != 'pr1'
      // test vybarvenosti predchozi bunky
      var predchozi_id = parseInt(cislo) - subjects.length;
  
      if (document.getElementById(td+'bunka_' + predchozi_id).style.backgroundColor == '') {
        print_modal('modal','neutr',"Zkus vybírat buňky tabulky popořadě!");
        return;
      }
      if (document.getElementById(td+'bunka_' + predchozi_id).style.backgroundColor == 'green') {
        return;
      }
    }
    //if(td != 'pr1'){
      var nasledujici_id = parseInt(cislo) + subjects.length;
      if (document.getElementById(td+'bunka_' + nasledujici_id).style.backgroundColor == 'orange') {
        print_modal('modal','neutr',"Tohle políčko nemůžeš odbarvit!");
        return;
      }
    //}
    if (elm.style.backgroundColor == 'green') {   
      return;
    }
    
    if (elm.style.backgroundColor != 'orange') {
      elm.style.backgroundColor = 'orange';
      vybrano[td][prvek] += 1;
    } else {
      elm.style.backgroundColor = '';
      vybrano[td][prvek] -= 1;
    }
  }

  if(td == 'pr1'){
    //tenhle vykresli cely sloupecek 
    //vykreslim sloupecek
    let sloupecek = cislo % 6;
    let pocet_policek = Math.floor(cislo/6)+1;
    let policko;
    for(let x = 0; x < 14; x++){
        policko = document.getElementById("pr1bunka_"+(x*6+sloupecek));
        if(x < pocet_policek){          
            //obarvim
            //policko.setAttribute("class","rozvrh_barvy");
            policko.style.backgroundColor = "orange";
        }
        else{
            //odbarvim
            policko.removeAttribute("style");
        }    
    }
    vybrano[td][prvek] = pocet_policek;
  }
} 

function tvorba_hodnoceni(){
  let malo = 0;
  let moc = 0;
  for(let i = 0;i<6;i++){
    if(pocty_predmetu[i] < navolene_predmety[i]){
      moc +=1;
    }else if(pocty_predmetu[i] > navolene_predmety[i]){
      malo += 1;
    }       
  }
  if(malo == 0 && moc ==0)
    print_modal("modal","ok");
  else if(malo > moc)
    print_modal("modal","chyba","Musíš splnit ještě "+malo+" předmětů.");
  else if(malo < moc)
    print_modal("modal","chyba","Máš moc hodin u "+malo+" předmětů.");
  else
    print_modal("modal","chyba","U některých předmětů máš moc hodin a ještě ti něco schází zapsat.");
}

function reset_rozvrh(){
  let vyplneno = document.getElementsByClassName('drop');
  for(let x = 0; x<vyplneno.length; x++)
    vyplneno[x].innerText = "";
  
  for(let x = 0; x < navolene_predmety.length; x++)
    navolene_predmety[x] = 0;
    
    
  drag_drop();
}

function vyhodnotit(td) {
  //alert('Provádím vyhodnocování');           
  var m, n, o, p;  
  p = 0;
  
  for (m = 0; m < subjects.length; m++) {
    //console.log('verifikace ' + subjects[m] + ': ' + pocty[m] + '==' + vybrano[m]);
    if (pocty[td][m] == vybrano[td][m]) {
      //alert('v poradku');
      p = p + 1;
      
      // projedu vsechny radky
      o = m;
      for (n = 0; n < radekCheckTable - 1; n++) {        
        var bunka = document.getElementById(td+'bunka_' + o);
        //console.log(m);
        if (bunka.style.backgroundColor == 'orange') {
          bunka.style.backgroundColor = 'cyan';
        }
        
        o += subjects.length; // iteruji radky pro jeden konkreni sloupec
      }
    }
    else {
      
      o = m;
      for (n = 0; n < radekCheckTable - 1; n++) {        
        var bunka = document.getElementById(td+'bunka_' + o);
        //console.log(m);
        if (bunka.style.backgroundColor == 'cyan') {
          bunka.style.backgroundColor = 'orange';
        }
        
        o += subjects.length; // iteruji radky pro jeden konkreni sloupec
      }
    }
  }
  if(p != 6)
    print_modal('modal', 'neutr','Počet správně vyřešených předmětů: ' + p + '. Určitě zvládnš všechny!');
  else
    print_modal('modal','ok');
}

/* draggable */  
function drag_drop(){
  jQuery( ".drag" ).draggable({ revert: "invalid" });
  jQuery( ".drop" ).droppable({
    drop: function(event, ui ) {
      event.preventDefault();
      event.target.appendChild(ui.draggable[0]);
      //odeberu css, co se tam strka
      ui.draggable[0].removeAttribute("style");
      //scitam 
      switch(ui.draggable[0].innerText){
        case "MAT": navolene_predmety[0] +=1; break; 
        case "CJ": navolene_predmety[1] +=1; break; 
        case "CHE": navolene_predmety[2] +=1; break; 
        case "INF": navolene_predmety[3] +=1; break; 
        case "DEJ": navolene_predmety[4] +=1; break; 
        case "TV": navolene_predmety[5] +=1; break; 
      }    
      //udelam nove
      if(ui.draggable[0].classList.length != 0){
        let span_sub = ui.draggable[0].cloneNode(true);
        jQuery(span_sub).draggable({ revert: "invalid" });
        document.getElementById('subjects').appendChild(span_sub);
        jQuery(ui.draggable[0]).draggable( "destroy" );
        ui.draggable[0].removeAttribute("class");
        jQuery(event.target).droppable( "destroy" );
      }     
      
      //console.log(navolene_predmety);
    }   
  });
}


//hlavni

initApplication();
document.getElementById("vyhodnoceni_pr1").addEventListener("click", function(){
    vyhodnotit('pr1');
});

document.getElementById("vyhodnoceni_pr2").addEventListener("click", function(){
    vyhodnotit('pr2');
});

document.getElementById("vyhodnoceni_pr3").addEventListener("click", function(){
    tvorba_hodnoceni();
});

document.getElementById("vyhodnoceni_reset").addEventListener("click", function(){
    reset_rozvrh();
});

drag_drop();


     